// Demonstruje deklaraci konstruktoru a
// destruktoru pro trdu Kocka
// Programatorem vytvoren vchoz konstruktor

#include <iostream>		// kvuli cout

class Kocka                    // zactek deklarace trdy
{
public:						   // zactek sekce public
	Kocka(int iniVek);	       // konstruktor
	~Kocka();				   // destruktor
	int ZiskejVek();           // funkce pro prstup k datum
	void NastavVek (int vek);  // funkce pro prstup k datum
	void Mnau();               // obecn funkce
private:					   // zactek sekce private
	int jejiVek;               // clensk promenn
};

// konstruktor tridy Kocka
Kocka::Kocka(int iniVek)
{
   jejiVek = iniVek;
}

Kocka::~Kocka()                // destruktor, dn akce
{
}

// ZiskejVek, verejn funkce pro prstup k datum
// vrac hodnotu clensk promenn jejiVek
int Kocka::ZiskejVek()
{
	return jejiVek;
}

// definice NastavVek, verejn
// funkce pro prstup k datum
// nastavuje clenskou promennou jejiVek
void Kocka::NastavVek(int vek)
{
	// nastaven clensk promenn jejiVek na
	// hodnotu predanou parametrem vek
	jejiVek = vek;
}

// definice metody Mnau
// vrac: void
// parametry: dn
// akce: Vytiskne na obrazovku "Mnau"
void Kocka::Mnau()
{
	std::cout << "Mnau.\n";
}

// zalo objekt kocky, nastav jej vek, nech ji zamnoukat,
// vytiskne jej vek, pak zamnouk znovu.
int main()
{
	Kocka Micka(5);
	Micka.Mnau();
	std::cout << "Micka je kocka, ktere je " ;
	std::cout << Micka.ZiskejVek() << " let.\n";
	Micka.Mnau();
	Micka.NastavVek(7);
	std::cout << "Micce je nyni " ;
	std::cout << Micka.ZiskejVek() << " let.\n";
	return 0;
}
