// Zactek Obdlnk.hpp

#include <iostream>
class Bod     // udruje souradnice x,y
{
// dn konstruktor, pouv se vchoz
public:
	void NastavX(int x) { hodnotaX = x; }
	void NastavY(int y) { hodnotaY = y; }
	int ZiskejX()const { return hodnotaX;}
	int ZiskejY()const { return hodnotaY;}
private:
	int hodnotaX;
	int hodnotaY;
};    // konec deklarace trdy Bod


class Obdelnik
{
public:
	Obdelnik (int horni, int levy, int spodni, int pravy);
	~Obdelnik () {}

	int ZiskejHorni() const { return hodnotaHorni; }
	int ZiskejLevy() const { return hodnotaLevy; }
	int ZiskejSpodni() const { return hodnotaSpodni; }
	int ZiskejPravy() const { return hodnotaPravy; }

	Bod  ZiskejHorniLevy() const { return hodnotaHorniLevy; }
	Bod  ZiskejSpodniLevy() const { return hodnotaSpodniLevy; }
	Bod  ZiskejHorniPravy() const { return hodnotaHorniPravy; }
	Bod  ZiskejSpodniPravy() const { return hodnotaSpodniPravy; }

	void NastavHorniLevy(Bod Umisteni)  {hodnotaHorniLevy = Umisteni;}
	void NastavSpodniLevy(Bod Umisteni)  {hodnotaSpodniLevy = Umisteni;}
	void NastavHorniPravy(Bod Umisteni)  {hodnotaHorniPravy = Umisteni;}
	void NastavSpodniPravy(Bod Umisteni)  {hodnotaSpodniPravy = Umisteni;}

	void NastavHorni(int horni) { hodnotaHorni = horni; }
	void NastavLevy (int levy) { hodnotaLevy = levy; }
	void NastavSpodni (int spodni) { hodnotaSpodni = spodni; }
	void NastavPravy (int pravy) { hodnotaPravy = pravy; }

	int ZiskejPlochu() const;

private:
	Bod  hodnotaHorniLevy;
	Bod  hodnotaHorniPravy;
	Bod  hodnotaSpodniLevy;
	Bod  hodnotaSpodniPravy;
	int    hodnotaHorni;
	int    hodnotaLevy;
	int    hodnotaSpodni;
	int    hodnotaPravy;
};
// konec Obdelnik.hpp
