// Zactek Obdelnik.cpp

#include "obdelnik.hpp"
Obdelnik::Obdelnik(int horni, int levy, int spodni, int pravy)
{
	hodnotaHorni = horni;
	hodnotaLevy = levy;
	hodnotaSpodni = spodni;
	hodnotaPravy = pravy;

	hodnotaHorniLevy.NastavX(levy);
	hodnotaHorniLevy.NastavY(horni);

	hodnotaHorniPravy.NastavX(pravy);
	hodnotaHorniPravy.NastavY(horni);

	hodnotaSpodniLevy.NastavX(levy);
	hodnotaSpodniLevy.NastavY(spodni);

	hodnotaSpodniPravy.NastavX(pravy);
	hodnotaSpodniPravy.NastavY(spodni);
}


// spoct plochu obdlnku tak, ze zska rku a vku jako
// rozdly v souradnicch rohovch bodu a pak je vynsob
int Obdelnik::ZiskejPlochu() const
{
	int Sirka = hodnotaPravy-hodnotaLevy;
	int Vyska = hodnotaHorni - hodnotaSpodni;
	return (Sirka * Vyska);
}

int main()
{
	//inicializace lokln promenn Obdelnik
	Obdelnik MujObdelnik (100, 20, 50, 80 );

	int Plocha = MujObdelnik.ZiskejPlochu();

	std::cout << "Plocha: " << Plocha << "\n";
	std::cout << "X-ova souradnice horniho leveho bodu: ";
	std::cout << MujObdelnik.ZiskejHorniLevy().ZiskejX();
	return 0;
}
