// Vpis 10.12
// Vrcen dereferencovanho ukazatele "this"

#include <iostream>

using namespace std;

class Citac
{
public:
	Citac();
	~Citac(){}
	int ZiskejHodnotu()const { return hodnota; }
	void NastavHodnotu(int x) { hodnota = x; }
	const Citac& operator++ ();    // prefixov opertor
	const Citac operator++ (int);    // postfixov opertor

private:
	int hodnota;

};

Citac::Citac():
hodnota(0)
{}

const Citac& Citac::operator++()
{
	++hodnota;
	return *this;
}

const Citac Citac::operator++(int priznak)
{
	Citac pom(*this);
	++hodnota;
	return pom;
}

int main()
{
	Citac i;
	cout << "Hodnota citace i je " << i.ZiskejHodnotu() << endl;
	i++;
	cout << "Hodnota citace i je " << i.ZiskejHodnotu() << endl;
	++i;
	cout << "Hodnota citace i je " << i.ZiskejHodnotu() << endl;
	Citac a = ++i;
	cout << "Hodnota a: " << a.ZiskejHodnotu();
	cout << " a hodnota i: " << i.ZiskejHodnotu() << endl;
	a = i++;
	cout << "Hodnota a: " << a.ZiskejHodnotu();
	cout << " a hodnota i: " << i.ZiskejHodnotu() << endl;
	return 0;
}