// Vpis 14.5
// Spolen bzov tda

#include <iostream>
using namespace std;

typedef int SAHY;
enum BARVA { Cervena, Zelena, Modra, Zluta, Bila, Cerna, Hneda } ;

class Zvire        // common base to both horse and bird
{
public:
	Zvire(int);
	virtual ~Zvire() { cout << "Destruktor Zvire...\n"; }
	virtual int ZjistitVek() const { return jehoVek; }
	virtual void ZadatVek(int vek) { jehoVek = vek; }
private:
	int jehoVek;
};

Zvire::Zvire(int vek):
jehoVek(vek)
{
	cout << "Konstruktor Zvire...\n";
}

class Kun : public Zvire
{
public:
	Kun(BARVA barva, SAHY vyska, int vek);
	virtual ~Kun() { cout << "Destruktor Kun...\n"; }
	virtual void Rehtat()const { cout << "Iihaha!... "; }
	virtual SAHY ZjistitVysku() const { return jehoVyska; }
	virtual BARVA ZjistitBarvu() const { return jehoBarva; }
protected:
	SAHY jehoVyska;
	BARVA jehoBarva;
};

Kun::Kun(BARVA barva, SAHY vyska, int vek):
Zvire(vek),
jehoBarva(barva),jehoVyska(vyska)
{
	cout << "Konstruktor Kun...\n";
}

class Ptak : public Zvire
{
public:
	Ptak(BARVA barva, bool migruje, int vek);
	virtual ~Ptak() {cout << "Destruktor Ptak...\n";  }
	virtual void Cvrlikat()const { cout << "Cvrliky... ";  }
	virtual void Letet()const
				{ cout << "Umim letat! Umim letat! Umim letat! "; }
	virtual BARVA ZjistitBarvu()const { return jehoBarva; }
	virtual bool ZjistitMigraci() const { return jehoMigrace; }
protected:
	BARVA jehoBarva;
	bool jehoMigrace;
};

Ptak::Ptak(BARVA barva, bool migruje, int vek):
Zvire(vek),
jehoBarva(barva), jehoMigrace(migruje)
{
	cout << "Konstruktor Ptak...\n";
}

class Pegas : public Kun, public Ptak
{
public:
	void Cvrlikat()const { Rehtat(); }
	Pegas(BARVA, SAHY, bool, long, int);
	virtual ~Pegas() {cout << "Destruktor Pegas...\n";}
	virtual long ZjistitPocetVericich() const
	{ return  jehoPocetVericich; }
	virtual BARVA ZjistitBarvu()const { return Kun::jehoBarva; }
	virtual int ZjistitVek() const { return Kun::ZjistitVek(); }
private:
	long jehoPocetVericich;
};

Pegas::Pegas(
	BARVA nejakaBarva,
	SAHY vyska,
	bool migruje,
	long PocetVericich,
	int vek):
	Kun(nejakaBarva, vyska,vek),
	Ptak(nejakaBarva, migruje,vek),
	jehoPocetVericich(PocetVericich)
{
	cout << "Konstruktor Pegas...\n";
}

int main()
{
	Pegas *pPegas = new Pegas(Cervena, 5, true, 10, 2);
	int vek = pPegas->ZjistitVek();
	cout << "Tomuto pegasovi je " << vek << " let.\n";
	delete pPegas;
	return 0;
}
