//Vpis 14.9 Implementovn ist virtulnch funkc

#include <iostream>
using namespace std;

class Tvar
{
public:
    Tvar(){}
    virtual ~Tvar(){}
    virtual long ZjistitPlochu() = 0; // chyba
    virtual long ZjistitObvod()= 0;
    virtual void Nakreslit() = 0;
private:
};

void Tvar::Nakreslit()
{
    cout << "Abstraktni mechanismus kresleni!\n";
}

class Kruznice : public Tvar
{
public:
    Kruznice(int polomer):jejiPolomer(polomer){}
    virtual ~Kruznice(){}
    long ZjistitPlochu() { return 3 * jejiPolomer * jejiPolomer; }
    long ZjistitObvod() { return 9 * jejiPolomer; }
    void Nakreslit();
private:
    int jejiPolomer;
    int jejiObvod;
};

void Kruznice::Nakreslit()
{
    cout << "Zde je rutina kresleni kruznice!\n";
    Tvar::Nakreslit();
}


class Obdelnik : public Tvar
{
public:
    Obdelnik(int delka, int sirka):
    jehoDelka(delka), jehoSirka(sirka){}
    virtual ~Obdelnik(){}
    long ZjistitPlochu() { return jehoDelka * jehoSirka; }
    long ZjistitObvod() {return 2*jehoDelka + 2*jehoSirka; }
    virtual int ZjistitDelku() { return jehoDelka; }
    virtual int ZjistitSirku() { return jehoSirka; }
    void Nakreslit();
private:
    int jehoSirka;
    int jehoDelka;
};

void Obdelnik::Nakreslit()
{
    for (int i = 0; i<jehoDelka; i++)
    {
        for (int j = 0; j<jehoSirka; j++)
            cout << "x ";

    cout << "\n";
    }
    Tvar::Nakreslit();
}


class Ctverec : public Obdelnik
{
public:
    Ctverec(int delka);
    Ctverec(int delka, int sirka);
    virtual ~Ctverec(){}
    long ZjistitObvod() {return 4 * ZjistitDelku();}
};

Ctverec::Ctverec(int delka):
Obdelnik(delka,delka)
{}

Ctverec::Ctverec(int delka, int sirka):
Obdelnik(delka,sirka)

{
    if (ZjistitDelku()!= ZjistitSirku())
    cout << "Chyba, najedna se o ctverec... obdelnik??\n";
}

int main()
{
    int volba;
    bool fKonec = false;
    Tvar * tv;

    while (1)
    {
        cout << "(1)Kruznice (2)Obdelnik (3)Ctverec (0)Konec: ";
        cin >> volba;

        switch (volba)
        {
        case 1: tv = new Kruznice(5);
                break;
        case 2: tv = new Obdelnik(4,6);
                break;
        case 3: tv = new Ctverec (5);
                break;
        default: fKonec = true;
                break;
        }
        if (fKonec)
            break;

        tv->Nakreslit();
        delete tv;
        cout << "\n";
    }
    return 0;
}
