//Vpis 17.20 Pouvn argument pkazovho dku
#include <fstream>
#include <iostream>
using namespace std;

class Zvire
{
public:
    Zvire(int vaha,long dnu):jehoVaha(vaha),DnuNazivu(dnu){}
    ~Zvire(){}

    int ZjistitVahu()const { return jehoVaha; }
    void ZadatVahu(int vaha) { jehoVaha = vaha; }

    long ZjistitDnuNazivu()const { return  DnuNazivu; }
    void ZadatDnuNazivu(long dnu) { DnuNazivu = dnu; }

private:
    int jehoVaha;
    long DnuNazivu;
};

int main(int argc, char *argv[])   // vrac 1 pi chyb
{
    if (argc != 2)
    {
        cout << "Pouziti: " << argv[0] << " <nazevSouboru>" << endl;
        return(1);
    }

    ofstream fout(argv[1],ios::binary);
    if (!fout)
    {
        cout << "Nelze otevrit " << argv[1] << " pro zapis.\n";
        return(1);
    }

    Zvire Medved(50,100);
    fout.write((char*) &Medved,sizeof Medved);

    fout.close();

    ifstream fin(argv[1],ios::binary);
    if (!fin)
    {
        cout << "Nelze otevrit " << argv[1] << " pro cteni.\n";
        return(1);
    }

    Zvire MedvedDva(1,1);

    cout << "MedvedDva vaha: " << MedvedDva.ZjistitVahu() << endl;
    cout << "MedvedDva dnu: " << MedvedDva.ZjistitDnuNazivu() << endl;

    fin.read((char*) &MedvedDva, sizeof MedvedDva);

    cout << "MedvedDva vaha: " << MedvedDva.ZjistitVahu() << endl;
    cout << "MedvedDva dnu: " << MedvedDva.ZjistitDnuNazivu() << endl;
    fin.close();
    return 0;
}
