// Vpis 8.10
// Pouvn ukazatel spolu s konstantnmi metodami

#include <iostream>
using namespace std;

class Obdelnik
{
public:
   Obdelnik();
   ~Obdelnik();
   void NastavDelku(int delka) { delkaObd = delka; }
   int ZiskejDelku() const { return delkaObd; }
   void NastavSirku(int sirka) { sirkaObd = sirka; }
   int ZiskejSirku() const { return sirkaObd; }

private:
   int delkaObd;
   int sirkaObd;
};

Obdelnik::Obdelnik()
{
   sirkaObd = 5;
   delkaObd = 10;
}

Obdelnik::~Obdelnik()
{}

int main()
{
   Obdelnik * ukObd = new Obdelnik;
   const Obdelnik * ukKonstObd = new Obdelnik;
   Obdelnik * const ukKonstUkaz = new Obdelnik;

   cout << "ukObd sirka: " << ukObd->ZiskejSirku()
      << " centimetru\n";
   cout << "ukKonstObd sirka: " << ukKonstObd->ZiskejSirku()
      << " centimetru\n";
   cout << "ukKonstUkaz sirka: " << ukKonstUkaz->ZiskejSirku()
      << " centimetru\n";

   ukObd->NastavSirku(10);
   // ukKonstObd->NastavSirku(10);
   ukKonstUkaz->NastavSirku(10);

   cout << "ukObd sirka: " << ukObd->ZiskejSirku()
      << " centimetru\n";
   cout << "ukKonstObd sirka: " << ukKonstObd->ZiskejSirku()
      << " centimetru\n";
   cout << "ukKonstUkaz sirka: " << ukKonstUkaz->ZiskejSirku()
      << " centimetru\n";
   return 0;
}