#include <iostream>
#include <ctype.h>
#include <string.h>

bool ZiskejSlovo(char * retezec,
                 char * slovo, int& posunSlovo);

// dic program
int main()
{
   const int velPamet = 255;
   char pamet[velPamet+1];   // pam pro uchovn celho etzce
   char slovo[velPamet+1];   // pam pro uchovn slova
   int posunSlovo = 0;       // zanme na zatku

   std::cout << "Vlozte retezec: ";
   std::cin.getline(pamet,velPamet);

   while (ZiskejSlovo(pamet,slovo,posunSlovo))
   {
      std::cout << "Ziskano slovo: " << slovo << std::endl;
   }

   return 0;

}


// funkce pro rozklad etzce a zskn slova
bool ZiskejSlovo(char* retezec, char* slovo, int& posunSlovo)
{

   if (!retezec[posunSlovo])    // konec etzce?
      return false;

   char *p1, *p2;
   p1 = p2 = retezec+posunSlovo;   // uka na nsledujc slovo

   // pohlcen potench mezer
   for (int i = 0; i<(int)strlen(p1) && !isalnum(p1[0]); i++)
      p1++;

   // podvejme se, jestli mme slovo
   if (!isalnum(p1[0]))
      return false;

   // p1 nyn ukazuje na zatek nsledujcho slova
   // nechme p2 ukazovat na stejn msto
   p2 = p1;

   // pejdme s p2 na konec slova
   while (isalnum(p2[0]))
      p2++;

   // p2 nyn ukazuje na konec slova
   // p1 nyn ukazuje na zatek slova
   // dlka slova je jejich rozdl
   int delka = int (p2 - p1);

   // zkoprovn slova do pipraven pamti
   strncpy (slovo,p1,delka);

   // ukonme etzec nulou
   slovo[delka]='\0';

   // nyn najdeme zatek nsledujcho slova
   for (int j = int(p2-retezec); j<(int)strlen(retezec)
      && !isalnum(p2[0]); j++)
   {
      p2++;
   }

   posunSlovo = int(p2-retezec);

   return true;
}