// Vpis 9.12
// Pedvn odkaz na objekty

#include <iostream>

using namespace std;
class ProstaKocka
{
public:
   ProstaKocka ();
   ProstaKocka(ProstaKocka&);
   ~ProstaKocka();

   int ZiskejVek() const { return vekKocky; }
   void NastavVek(int vek) { vekKocky = vek; }

private:
   int vekKocky;
};

ProstaKocka::ProstaKocka()
{
   cout << "Prosta Kocka: Konstruktor...\n";
    vekKocky = 1;
}

ProstaKocka::ProstaKocka(ProstaKocka&)
{
   cout << "Prosta Kocka: Konstruktor pro kopirovani...\n";
}

ProstaKocka::~ProstaKocka()
{
   cout << "Prosta Kocka: Desktruktor...\n";
}

const ProstaKocka & Funkce2 (const ProstaKocka & kocka);

int main()
{
   cout << "Vytvoreni kocky...\n";
   ProstaKocka Micka;
   cout << "Micka ma " << Micka.ZiskejVek() << " roku\n";
   int vek = 5;
   Micka.NastavVek(vek);
   cout << "Micka ma " << Micka.ZiskejVek() << " roku\n";
   cout << "Volani Funkce2...\n";
   Funkce2(Micka);
   cout << "Micka ma " << Micka.ZiskejVek() << " roku\n";
   return 0;
}

// Funkce2, pedn odkazem
const ProstaKocka & Funkce2 (const ProstaKocka & kocka)
{
   cout << "Funkce2, navrat...\n";
   cout << "Micka ma nyni " << kocka.ZiskejVek();
   cout << " roku\n";
   // kocka.NastavVek(8);   const!
   return kocka;
}