// Vpis 10.5
// Konstruktory pro koprovn

#include <iostream>
using namespace std;

class KOCKA
{
public:
	KOCKA();				// vchoz konstruktor
	KOCKA (const KOCKA &);	// konstruktor pro koprovn
	~KOCKA();				// destruktor
	int ZiskejVek()		const	{ return *vekKocky; }
	int ZiskejVahu()	const	{ return *vahaKocky; }
	void NastavVek(int vek)		{ *vekKocky = vek; }

private:
	int *vekKocky;
	int *vahaKocky;
};

KOCKA::KOCKA()
{
	vekKocky = new int;
	vahaKocky = new int;
	*vekKocky = 5;
	*vahaKocky = 9;
}

KOCKA::KOCKA(const KOCKA & ptr)
{
	vekKocky = new int;
	vahaKocky = new int;
	*vekKocky = ptr.ZiskejVek();   // veejn pstup
	*vahaKocky = *(ptr.vahaKocky); // privtn pstup
}

KOCKA::~KOCKA()
{
	delete vekKocky;
	vekKocky = 0;
	delete vahaKocky;
	vahaKocky = 0;
}

int main()
{
	KOCKA micka;
	cout << "Vek Micky je: " << micka.ZiskejVek() << endl;
	cout << "Nastaveni veku Micky na 6...\n";
	micka.NastavVek(6);
	cout << "Vytvoreni Mourka na zaklade Micky\n";
	KOCKA mourek(micka);
	cout << "Vek Micky je: " << micka.ZiskejVek() << endl;
	cout << "Vek Mourka je: " << mourek.ZiskejVek() << endl;
	cout << "Nastaveni veku Micky na 7...\n";
	micka.NastavVek(7);
	cout << "Vek Micky je: " << micka.ZiskejVek() << endl;
	cout << "Vek Mourka je: " << mourek.ZiskejVek() << endl;
	return 0;
}
