//Vpis 12.3 Voln konstruktor a destruktor

#include <iostream>
enum RASA { ZLATY_RETRIEVER, PUDL, JEZEVCIK, OVCAK, DOBRMAN, LABRADOR };

class Savec
{
public:
    // Konstruktory
    Savec();
    ~Savec();

    // Pstupov metody
    int ZjistitVek() const { return jehoVek; }
    void ZadatVek(int vek) { jehoVek = vek; }
    int ZjistitVahu() const { return jehoVaha; }
    void ZadatVahu(int vaha) { jehoVaha = vaha; }

    // Dal metody
    void Promluvit() const { std::cout << "Zvuk savce!\n"; }
    void Spat() const { std::cout << "Psssst. Prave spim.\n"; }


protected:
    int jehoVek;
    int jehoVaha;
};

class Pes : public Savec
{
public:

    // Konstruktory
    Pes();
    ~Pes();

    // Pstupov metody
    RASA ZjistitRasu() const { return jehoRasa; }
    void ZadatRasu(RASA rasa) { jehoRasa = rasa; }

    // Dal metody
    void VrtetOcasem() const { std::cout << "Vrti ocasem...\n"; }
    void PrositOJidlo() const { std::cout << "Prosi o jidlo...\n"; }

private:
    RASA jehoRasa;
};

Savec::Savec():
jehoVek(1),
jehoVaha(5)
{
    std::cout << "Konstruktor Savec...\n";
}

Savec::~Savec()
{
    std::cout << "Destruktor Savec...\n";
}

Pes::Pes():
jehoRasa(ZLATY_RETRIEVER)
{
    std::cout << "Konstruktor Pes...\n";
}

Pes::~Pes()
{
    std::cout << "Destruktor Pes...\n";
}
int main()
{
    Pes fido;
    fido.Promluvit();
    fido.VrtetOcasem();
    std::cout << "Fidovi je " << fido.ZjistitVek() << " let\n";
    return 0;
}
