//Vpis 12.11 Virtuln koprovac konstruktor

#include <iostream>
using namespace std;

class Savec
{
public:
    Savec():jehoVek(1) { cout << "Konstruktor Savec...\n"; }
    virtual ~Savec() { cout << "Destruktor Savec...\n"; }
    Savec (const Savec & rhs);
    virtual void Promluvit() const { cout << "Savec hovori!\n"; }
    virtual Savec* Klonovat() { return new Savec(*this); }
    int ZjistitVek()const { return jehoVek; }
protected:
    int jehoVek;
};

Savec::Savec (const Savec & rhs):jehoVek(rhs.ZjistitVek())
{
    cout << "Kopirovaci konstruktor Savec...\n";
}

class Pes : public Savec
{
public:
    Pes() { cout << "Konstruktor Pes...\n"; }
    virtual ~Pes() { cout << "Destruktor Pes...\n"; }
    Pes (const Pes & rhs);
    void Promluvit()const { cout << "Haf!\n"; }
    virtual Savec* Klonovat() { return new Pes(*this); }
};

Pes::Pes(const Pes & rhs):
Savec(rhs)
{
    cout << "Kopirovaci konstruktor Pes...\n";
}

class Kocka : public Savec
{
public:
    Kocka() { cout << "Konstruktor Kocka...\n"; }
    ~Kocka() { cout << "Destruktor Kocka...\n"; }
    Kocka (const Kocka &);
    void Promluvit()const { cout << "Mnau!\n"; }
    virtual Savec* Klonovat() { return new Kocka(*this); }
};

Kocka::Kocka(const Kocka & rhs):
Savec(rhs)
{
    cout << "Kopirovaci konstruktor Kocka...\n";
}

enum ZVIRATA { SAVEC, PES, KOCKA};
const int pocetTypuZvirat = 3;
int main()
{
    Savec *toPole[pocetTypuZvirat];
    Savec* ukz;
    int volba, i;
    for ( i = 0; i<pocetTypuZvirat; i++)
    {
        cout << "(1)pes (2)kocka (3)Savec: ";
        cin >> volba;
        switch (volba)
        {
        case PES:    ukz = new Pes;
                    break;
        case KOCKA:    ukz = new Kocka;
                    break;
        default:    ukz = new Savec;
                    break;
        }
        toPole[i] = ukz;
    }
    Savec *JinePole[pocetTypuZvirat];
    for (i=0;i<pocetTypuZvirat;i++)
    {
        toPole[i]->Promluvit();
        JinePole[i] = toPole[i]->Klonovat();
    }
    for (i=0;i<pocetTypuZvirat;i++)
        JinePole[i]->Promluvit();
    return 0;
}
