// Vpis 14.3. Vcensobn ddinost
// Vcensobn ddinost

#include <iostream>
using std::cout;
using std::cin;

class Kun
{
public:
	Kun() { cout << "Konstruktor Kun... "; }
	virtual ~Kun() { cout << "Destruktor Kun... "; }
	virtual void Rehtat() const { cout << "Iihaha!... "; }
private:
	int jehoVek;
};

class Ptak
{
public:
	Ptak() { cout << "Konstruktor Ptak... "; }
	virtual ~Ptak() { cout << "Destruktor Ptak... "; }
	virtual void Cvrlikat() const { cout << "Cvrliky... ";  }
	virtual void Letet() const
	{
		cout << "Umim letat! Umim letat! Umim letat! ";
	}
private:
	int jehoVaha;
};

class Pegas : public Kun, public Ptak
{
public:
	void Cvrlikat() const { Rehtat(); }
	Pegas() { cout << "Konstruktor Pegas... "; }
	~Pegas() { cout << "Destruktor Pegas...  "; }
};

const int MagickeCislo = 2;
int main()
{
	Kun* Ranc[MagickeCislo];
	Ptak* Voliera[MagickeCislo];
	Kun * pKun;
	Ptak * pPtak;
	int volba,i;
	for (i=0; i<MagickeCislo; i++)
	{
		cout << "\n(1)Kun (2)Pegas: ";
		cin >> volba;
		if (volba == 2)
			pKun = new Pegas;
		else
			pKun = new Kun;
		Ranc[i] = pKun;
	}
	for (i=0; i<MagickeCislo; i++)
	{
		cout << "\n(1)Ptak (2)Pegas: ";
		cin >> volba;
		if (volba == 2)
			pPtak = new Pegas;
		else
			pPtak = new Ptak;
		Voliera[i] = pPtak;
	}

	cout << "\n";
	for (i=0; i<MagickeCislo; i++)
	{
		cout << "\nRanch[" << i << "]: " ;
		Ranc[i]->Rehtat();
		delete Ranc[i];
	}

	for (i=0; i<MagickeCislo; i++)
	{
		cout << "\nVoliera [" << i << "]: " ;
		Voliera[i]->Cvrlikat();
		Voliera[i]->Letet();
		delete Voliera[i];
	}
	return 0;
}
