// Vpis 14.4
// Voln vce konstruktor

#include <iostream>
using namespace std;

typedef int SAHY;
enum BARVA { Cervena, Zelena, Modra, Zluta, Bila, Cerna, Hneda } ;

class Kun
{
public:
	Kun(BARVA barva, SAHY vyska);
	virtual ~Kun() { cout << "Destruktor Kun...\n"; }
	virtual void Rehtat()const { cout << "Iihaha!... "; }
	virtual SAHY ZjistitVysku() const { return jehoVyska; }
	virtual BARVA ZjistitBarvu() const { return jehoBarva; }
private:
	SAHY jehoVyska;
	BARVA jehoBarva;
};

Kun::Kun(BARVA barva, SAHY vyska):
jehoBarva(barva),jehoVyska(vyska)
{
	cout << "Konstruktor Kun...\n";
}

class Ptak
{
public:
	Ptak(BARVA barva, bool migruje);
	virtual ~Ptak() {cout << "Destruktor Ptak...\n";  }
	virtual void Cvrlikat()const { cout << "Cvrliky... ";  }
	virtual void Letet()const
	{
		cout << "Umim letat! Umim letat! Umim letat! ";
	}
	virtual BARVA ZjistitBarvu()const { return jehoBarva; }
	virtual bool ZjistitMigraci() const { return jehoMigrace; }

private:
	BARVA jehoBarva;
	bool jehoMigrace;
};

Ptak::Ptak(BARVA barva, bool migruje):
jehoBarva(barva), jehoMigrace(migruje)
{
	cout << "Konstruktor Ptak...\n";
}

class Pegas : public Kun, public Ptak
{
public:
	void Cvrlikat()const { Rehtat(); }
	Pegas(BARVA, SAHY, bool,long);
	~Pegas() {cout << "Destruktor Pegas...\n";}
	virtual long ZjistitPocetVericich() const
	{
		return  jehoPocetVericich;
	}

private:
	long jehoPocetVericich;
};

Pegas::Pegas(
	BARVA nejakaBarva,
	SAHY vyska,
	bool migruje,
	long PocetVericich):
	Kun(nejakaBarva, vyska),
	Ptak(nejakaBarva, migruje),
	jehoPocetVericich(PocetVericich)
{
cout << "Konstruktor Pegas...\n";
}

int main()
{
	Pegas *pPegas = new Pegas(Cervena, 5, true, 10);
	pPegas->Letet();
	pPegas->Rehtat();
	cout << "\nVas Pegas je " << pPegas->ZjistitVysku();
	cout << " sahy vysoky a ";
	if (pPegas->ZjistitMigraci())
		cout << "migruje.";
	else
		cout << "nemigruje.";
	cout << "\nCelkem " << pPegas->ZjistitPocetVericich();
	cout << " lidi veri, ze existuje.\n";
	delete pPegas;
	return 0;
}
