// Vpis 15.7 
// Ukzka pouit pole ukazatel na funkce

#include <iostream>
using namespace std;

void NaDruhou (int&,int&);
void NaTreti (int&, int&);
void Zamenit (int&, int &);
void ZjistitHodnoty(int&, int&);
void VytisknoutHodnoty(int, int);

int main()
{
    int hodnotaJedna=1, hodnotaDve=2;
    int volba, i;
    const MaxPole = 5;
    void (*pPoleFunkci[MaxPole])(int&, int&);

    for (i=0;i<MaxPole;i++)
    {
        cout << "(1)Zmenit hodnoty (2)NaDruhou (3)NaTreti (4)Zamenit: ";
        cin >> volba;
        switch (volba)
        {
        case 1:    pPoleFunkci[i] = ZjistitHodnoty; break;
        case 2:    pPoleFunkci[i] = NaDruhou; break;
        case 3:    pPoleFunkci[i] = NaTreti; break;
        case 4:    pPoleFunkci[i] = Zamenit; break;
        default:pPoleFunkci[i] = 0;
        }
    }

    for (i=0;i<MaxPole; i++)
    {
        if ( pPoleFunkci[i] == 0 )
            continue;
        pPoleFunkci[i](hodnotaJedna,hodnotaDve);
        VytisknoutHodnoty(hodnotaJedna,hodnotaDve);
    }
    return 0;
}

void VytisknoutHodnoty(int x, int y)
{
    cout << "x: " << x << " y: " << y << endl;
}

void NaDruhou (int & rX, int & rY)
{
    rX *= rX;
    rY *= rY;
}

void NaTreti (int & rX, int & rY)
{
    int docas;

    docas = rX;
    rX *= rX;
    rX = rX * docas;

    docas = rY;
    rY *= rY;
    rY = rY * docas;
}

void Zamenit(int & rX, int & rY)
{
    int docasna;
    docasna = rX;
    rX = rY;
    rY = docasna;
}

void ZjistitHodnoty (int & rHodnotaJedna, int & rHodnotaDve)
{
    cout << "Nova hodnota jedna: ";
    cin >> rHodnotaJedna;
    cout << "Nova hodnota dve: ";
    cin >> rHodnotaDve;
}
