//Vpis 15.10 Ukazatele na lensk funkce vyuvajc virtuln metody

#include <iostream>
using namespace std;

class Savec
{
public:
    Savec():jehoVek(1) {  }
    virtual ~Savec() { }
    virtual void Mluvit() const = 0;
    virtual void Pohybovat() const = 0;
protected:
    int jehoVek;
};

class Pes : public Savec
{
public:
    void Mluvit()const { cout << "Haf!\n"; }
    void Pohybovat() const { cout << "Prochazi...\n"; }
};


class Kocka : public Savec
{
public:
    void Mluvit()const { cout << "Mnau!\n"; }
    void Pohybovat() const { cout << "Krade se...\n"; }
};


class Kun : public Savec
{
public:
    void Mluvit()const { cout << "Iihaha!\n"; }
    void Pohybovat() const { cout << "Cvala...\n"; }
};


int main()
{
    void (Savec::*pFunkce)() const =0;
    Savec* ukaz =0;
    int Zvire;
    int Metoda;
    bool fKonec = false;

    while (fKonec == false)
    {
        cout << "(0)Konec (1)Pes (2)Kocka (3)Kun: ";
        cin >> Zvire;
        switch (Zvire)
        {
        case 1: ukaz = new Pes; break;
        case 2: ukaz = new Kocka; break;
        case 3: ukaz = new Kun; break;
        default: fKonec = true; break;
        }
        if (fKonec)
            break;

        cout << "(1)Mluvit  (2)Pohybovat: ";
        cin >> Metoda;
        switch (Metoda)
        {
        case 1: pFunkce = Savec::Mluvit; break;
        default: pFunkce = Savec::Pohybovat; break;
        }

        (ukaz->*pFunkce)();
        delete ukaz;
    }
    return 0;
}
