//Vpis 17.18 Zpis tdy do souboru
#include <fstream>
#include <iostream>
using namespace std;

class Zvire
{
public:
    Zvire(int vaha,long dnu):jehoVaha(vaha),DnuNazivu(dnu){}
    ~Zvire(){}

    int ZjistitVahu()const { return jehoVaha; }
    void ZadatVahu(int vaha) { jehoVaha = vaha; }

    long ZjistitDnuNazivu()const { return DnuNazivu; }
    void ZadatDnuNazivu(long dnu) { DnuNazivu = dnu; }

private:
    int jehoVaha;
    long DnuNazivu;
};

int main()   // vrac 1 pi chyb
{ 
    char nazevSouboru[80];

    cout << "Zadejte prosim nazev souboru: ";
    cin >> nazevSouboru;
    ofstream fout(nazevSouboru,ios::binary);
    if (!fout)
    {
        cout << "Nelze otevrit " << nazevSouboru << " pro zapis.\n";
        return(1);
    }

    Zvire Medved(50,100);
    fout.write((char*) &Medved,sizeof Medved);

    fout.close();

    ifstream fin(nazevSouboru,ios::binary);
    if (!fin)
    {
        cout << "Nelze otevrit " << nazevSouboru << " pro cteni.\n";
        return(1);
    }

    Zvire MedvedDva(1,1);

    cout << "MedvedDva vaha: " << MedvedDva.ZjistitVahu() << endl;
    cout << "MedvedDva dnu: " << MedvedDva.ZjistitDnuNazivu() << endl;

    fin.read((char*) &MedvedDva, sizeof MedvedDva);

    cout << "MedvedDva vaha: " << MedvedDva.ZjistitVahu() << endl;
    cout << "MedvedDva dnu: " << MedvedDva.ZjistitDnuNazivu() << endl;
    fin.close();
    return 0;
}
