#include <iostream>
using namespace std;
#include <string.h>

enum STUDIUM { Denni, Vecerni } ;
enum VSVZDELANI { NEDOKONCENO, DOKONCENO } ;
enum UBYTOVANI { KOLEJE, VLASTNI };
enum STRAVOVANI { PoloPenze, PlnaPenze, Vikendy, ZadneJidlo };

class student
{
public:
	student():
		studiumStudenta(Denni),
		vzdelaniStudenta(NEDOKONCENO),
		ubytovaniStudenta(KOLEJE),
		stravovaniStudenta(ZadneJidlo)
	{}
	~student(){}
	STUDIUM ZiskejStudium();
	void NastavStudium(STUDIUM);
	unsigned ZiskejStravovani() { return stravovaniStudenta; }

private:
	unsigned studiumStudenta : 1;
	unsigned vzdelaniStudenta : 1;
	unsigned ubytovaniStudenta : 1;
	unsigned stravovaniStudenta : 2;
};

STUDIUM student::ZiskejStudium()
{
	if (studiumStudenta)
		return Denni;
	else
		return Vecerni;
}

void student::NastavStudium(STUDIUM typStudia)
{
	studiumStudenta = typStudia;
}

int main()
{
	student Honza;

	if (Honza.ZiskejStudium()== Vecerni)
		cout << "Honza je vecerni student" << endl;
	else
		cout << "Honza je denni student" << endl;

	Honza.NastavStudium(Vecerni);

	if (Honza.ZiskejStudium())
		cout << "Honza je vecerni student" << endl;
	else
		cout << "Honza je denni student" << endl;

	cout << "Honzovo stravovani: " ;

	char Strav[80];
	switch (Honza.ZiskejStravovani())
	{
	case PoloPenze: strcpy(Strav,"polopenze"); break;
	case PlnaPenze: strcpy(Strav,"plna penze"); break;
	case Vikendy: strcpy(Strav,"vikendova penze"); break;
	case ZadneJidlo: strcpy(Strav,"zadne jidlo");break;
	default : cout << "Neco se pokazilo!\n"; break;
	}
	cout << Strav << endl;
	return 0;
}